//+------------------------------------------------------------------+
//|                                                    Zmey-v.03.mq4 |
//|                                           Copyright 2015, NickAC |
//|                                               karabas_72@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, NickAC"
#property link      "karabas_72@mail.ru"
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+

input string  s____                       = " ";
input string  StartTime                   = "09:01:00";  //    
input string  EndTime                     = "15:00:00";  //    
extern double Lots                        = 50.0;        // 
extern string exptime                     = "30";        //  
extern int    magic                       = 74196;      //  
extern int    slippage                    = 3;           // 
extern double LotMarti                    = 3;           //   

extern string   Moving_Averages              = " Moving Averages";
extern int            InpMAPeriod            = 7;
extern int            InpMAShift             = 0;
extern ENUM_MA_METHOD InpMAMethod            = MODE_EMA;
extern ENUM_APPLIED_PRICE MA_Applied_Price   = PRICE_MEDIAN;

extern string   MACD                         = " MACD";
extern int    InpFastEMA                     = 2;
extern int    InpSlowEMA                     = 15;
extern int    InpSignalSMA                   = 3;
extern ENUM_APPLIED_PRICE Macd_Applied_Price = PRICE_MEDIAN;

extern string   Parabolic                    = " Parabolic";
extern double InpSARStep                     = 0.3;
extern double InpSARMaximum                  = 0.2;

extern string Stochastic                     = " Stochastic";
input int InpKPeriod                         = 2;
input int InpDPeriod                         = 4;
input int InpSlowing                         = 2;

extern string CCI                            = " CCI";
input int InpCCIPeriod                       = 6;

double MacdCurrent,SignalCurrent,SignalMAPrevious,SignalMAThis,PriceCurrentOpen,PriceCurrentClose,
SignalParabolic,SignalStochastic_15,MainStochastic_15,SignalStochastic,MainStochastic,
SignalCCIPrevious,SignalCCIThis,SignalCCIPrevious_15,SignalCCIThis_15,lot;
int    ticket;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(Digits==3 || Digits==5)
     {
      slippage*=10;
     }
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   datetime EaStartTime = StringToTime(StartTime);  //    
   datetime EaEndTime = StringToTime(EndTime);      //    
   datetime CurrTime = TimeCurrent();               //      
   if(CurrTime<EaStartTime || CurrTime>=EaEndTime)
      return;                                       //      - 
     {
      MacdCurrent=iMACD(NULL,0,InpFastEMA,InpSlowEMA,InpSignalSMA,Macd_Applied_Price,MODE_MAIN,0);
      SignalCurrent=iMACD(NULL,0,InpFastEMA,InpSlowEMA,InpSignalSMA,Macd_Applied_Price,MODE_SIGNAL,0);
      SignalMAPrevious=iMA(NULL,0,InpMAPeriod,InpMAShift,InpMAMethod,MA_Applied_Price,1);
      SignalMAThis=iMA(NULL,0,InpMAPeriod,InpMAShift,InpMAMethod,MA_Applied_Price,0);
      SignalParabolic=iSAR(NULL,0,InpSARStep,InpSARMaximum,0);
      SignalStochastic_15=iStochastic(NULL,15,InpKPeriod,InpDPeriod,InpSlowing,MODE_SMA,0,1,0);
      MainStochastic_15=iStochastic(NULL,15,InpKPeriod,InpDPeriod,InpSlowing,MODE_SMA,0,0,0);
      SignalStochastic=iStochastic(NULL,0,InpKPeriod,InpDPeriod,InpSlowing,MODE_SMA,0,1,0);
      MainStochastic=iStochastic(NULL,0,InpKPeriod,InpDPeriod,InpSlowing,MODE_SMA,0,0,0);
      SignalCCIPrevious=iCCI(NULL,0,InpCCIPeriod,0,1);
      SignalCCIThis=iCCI(NULL,0,InpCCIPeriod,0,0);
      SignalCCIPrevious_15=iCCI(NULL,15,InpCCIPeriod,0,1);
      SignalCCIThis_15=iCCI(NULL,15,InpCCIPeriod,0,0);
      if(CountTrades()==0) CheckForOpen();
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
 {if(ModLots())
  {
      //-----   .
    if(SignalCurrent<MacdCurrent && SignalMAPrevious<SignalMAThis && 
      Ask>SignalParabolic && SignalStochastic_15<MainStochastic_15&&SignalStochastic<MainStochastic&&
      SignalCCIPrevious<SignalCCIThis&&SignalCCIPrevious_15<SignalCCIThis_15)
      {
       ticket=OrderSend(NULL,OP_BUY,lot,Ask,slippage,0,0,exptime,magic,0,Blue);
       if(ticket>0)
          return;
      }
//-----   .
    if(SignalCurrent>MacdCurrent && SignalMAPrevious>SignalMAThis && 
      Bid<SignalParabolic && SignalStochastic_15>MainStochastic_15&&SignalStochastic>MainStochastic&&
      SignalCCIPrevious>SignalCCIThis&&SignalCCIPrevious_15>SignalCCIThis_15)
      {
       ticket=OrderSend(NULL,OP_SELL,lot,Bid,slippage,0,0,exptime,magic,0,Red);
       if(ticket>0)
          return;
      }
  }
 }
//+------------------------------------------------------------------+
int CountTrades()
  {
   int count=0;
   for(int i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
            count++;
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
bool ModLots()
  {
   if(OrdersHistoryTotal()==0)
     {lot=Lots;}
   else
     for(int i=OrdersHistoryTotal()-1;i>=0;i--)
      {
       if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) continue;
       if((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()))
       {
        if(OrderProfit()<0)
          {lot=OrderLots()*LotMarti;break;}
        if(OrderProfit()==0)
          {lot=OrderLots();break;}
        else 
          {lot=Lots;break;}
       }
      }
   return(true);
  }
//+------------------------------------------------------------------+
